/*
 * COBOL
 */

grammar Fast;

fragment A : 'a' | 'A';
fragment B : 'b' | 'B';
fragment C : 'c' | 'C';
fragment D : 'd' | 'D';
fragment E : 'e' | 'E';
fragment F : 'f' | 'F';
fragment G : 'g' | 'G';
fragment H : 'h' | 'H';
fragment I : 'i' | 'I';
fragment J : 'j' | 'J';
fragment K : 'k' | 'K';
fragment L : 'l' | 'L';
fragment M : 'm' | 'M';
fragment N : 'n' | 'N';
fragment O : 'o' | 'O';
fragment P : 'p' | 'P';
fragment Q : 'q' | 'Q';
fragment R : 'r' | 'R';
fragment S : 's' | 'S';
fragment T : 't' | 'T';
fragment U : 'u' | 'U';
fragment V : 'v' | 'V';
fragment W : 'w' | 'W';
fragment X : 'x' | 'X';
fragment Y : 'y' | 'Y';
fragment Z : 'z' | 'Z';
fragment DIGIT : [0-9];
fragment HEX_DIGIT : [0-9a-fA-F];


SEPARATOR_COMMA: ',' [ \r\n\t]* -> channel(HIDDEN);
SEPARATOR_SEMICOLON: ';' -> channel(HIDDEN);
WS: [ \r\n\t]+ -> channel(HIDDEN);
INLINE_COMMENT: '*>' ~[\r\n]* -> channel(HIDDEN);

DOT: '.';
IDENTIFICATION: I D E N T I F I C A T I O N;
ID: I D;
DIVISION: D I V I S I O N;
ENVIRONMENT: E N V I R O N M E N T;
DATA: D A T A;
PROCEDURE: P R O C E D U R E;
PROGRAM_ID: P R O G R A M '-' I D
          | S A P '-' P R O G R A M '-' I D;
PROGRAM: P R O G R A M;
IS: I S;
INITIAL: I N I T I A L;
AUTHOR: A U T H O R;
CONFIGURATION: C O N F I G U R A T I O N;
SECTION: S E C T I O N;
SOURCE_COMPUTER: S O U R C E '-' C O M P U T E R;
WITH: W I T H;
DEBUGGING: D E B U G G I N G;
MODE: M O D E;
OBJECT_COMPUTER: O B J E C T '-' C O M P U T E R;
MEMORY: M E M O R Y;
SIZE: S I Z E;
WORDS : W O R D S;
CHARACTERS: C H A R A C T E R S;
MODULES: M O D U L E S;
COLLATING: C O L L A T I N G;
SEQUENCE: S E Q U E N C E;
SEGMENT_LIMIT: S E G M E N T '-' L I M I T;
INPUT_OUTPUT: I N P U T '-' O U T P U T;
FILE_CONTROL: F I L E '-' C O N T R O L;
I_O_CONTROL: I '-' O '-' C O N T R O L;
SPECIAL_NAMES: S P E C I A L '-' N A M E S;
FILE: F I L E;
WORKING_STORAGE: W O R K I N G '-' S T O R A G E;
LOCAL_STORAGE: L O C A L  '-' S T O R A G E;
LINKAGE: L I N K A G E;
DECLARATIVES: D E C L A R A T I V E S;
USING: U S I N G;
END: E N D;
GOBACK: G O B A C K;
GO: G O;
TO: T O;
L_PAREN: '(';
R_PAREN: ')';
ACCEPT: A C C E P T;
FROM: F R O M;
DATE: D A T E;
DAY_OF_WEEK: D A Y '-' O F '-' W E E K;
TIME: T I M E;
ROUNDED: R O U N D E D;
ADD: A D D;
ON: O N ;
ERROR: E R R O R;
END_ADD: E N D '-' A D D;
GIVING: G I V I N G;
NOT: N O T;
CORRESPONDING: C O R R E S P O N D I N G;
CORR: C O R R;
LINAGE_COUNTER: L I N A G E '-' C O U N T E R;
COLON: ':';
IN: I N;
OF: O F;
ZERO: Z E R O;
ZEROS: Z E R O S;
ZEROES: Z E R O E S;
SPACE: S P A C E;
SPACES: S P A C E S;
HIGH_VALUE: H I G H '-' V A L U E;
HIGH_VALUES: H I G H '-' V A L U E S;
LOW_VALUE: L O W '-' V A L U E;
LOW_VALUES: L O W '-' V A L U E S;
QUOTE: Q U O T E;
QUOTES: Q U O T E S;
ALL: A L L;
ALSO: A L S O;
NULL: N U L L;
NULLS: N U L L S;
ADDRESS: A D D R E S S;
DEBUG_ITEM: D E B U G '-' I T E M;
LENGTH: L E N G T H;
RETURN_CODE: R E T U R N '-' C O D E;
SHIFT_IN: S H I F T '-' I N;
SHIFT_OUT: S H I F T '-' O U T;
SORT_CONTROL: S O R T '-' C O N T R O L;
SORT_CORE_SIZE: S O R T '-' C O R E '-' S I Z E;
SORT_FILE_SIZE: S O R T '-' F I L E '-' S I Z E;
SORT_MESSAGE: S O R T '-' M E S S A G E;
SORT_MODE_SIZE: S O R T '-' M O D E '-' S I Z E;
SORT_RETURN: S O R T '-' R E T U R N;
TALLY: T A L L Y;
WHEN_COMPILED: W H E N '-' C O M P I L E D;
STATUS: S T A T U S;
ALPHABET: A L P H A B E T;
CLASS: C L A S S;
OFF: O F F ;
DECIMAL_POINT: D E C I M A L '-' P O I N T;
SYMBOLIC: S Y M B O L I C;
CURRENCY: C U R R E N C Y;
ARE: A R E;
SIGN: S I G N;
STANDARD: S T A N D A R D;
STANDARD_1: S T A N D A R D '-' '1';
STANDARD_2: S T A N D A R D '-' '2';
NATIVE: N A T I V E;
EBCDIC: E B C D I C;
THROUGH: T H R O U G H;
THRU: T H R U;
COMMA: C O M M A;
CODE_SET: C O D E '-' S E T;
FILLER: F I L L E R;
RECORDING: R E C O R D I N G;
BOTTOM: B O T T O M;
FOOTING: F O O T I N G;
AT: A T;
LINAGE: L I N A G E;
LINES: L I N E S;
REDEFINES: R E D E F I N E S;
LABEL: L A B E L;
VALUE: V A L U E;
OMITTED: O M I T T E D;
VARYING: V A R Y I N G;
DEPENDING: D E P E N D I N G;
BLOCK: B L O C K;
GLOBAL: G L O B A L;
EXTERNAL: E X T E R N A L;
SORT: S O R T;
SORT_MERGE: S O R T '-' M E R G E;
CONTAINS: C O N T A I N S;
FOR: F O R;
MULTIPLE: M U L T I P L E;
SAME: S A M E;
RERUN: R E R U N;
EVERY: E V E R Y;
POSITION: P O S I T I O N;
APPLY: A P P L Y;
REEL: R E E L;
UNIT: U N I T ;
WRITE_ONLY: W R I T E '-' O N L Y;
RECORDS: R E C O R D S;
SELECT: S E L E C T;
OPTIONAL: O P T I O N A L;
ASSIGN: A S S I G N;
RESERVE: R E S E R V E;
AREA: A R E A;
AREAS: A R E A S;
PADDING: P A D D I N G;
CHARACTER: C H A R A C T E R;
RECORD: R E C O R D;
DELIMITER: D E L I M I T E R;
KEY: K E Y;
ALTERNATE: A L T E R N A T E;
RELATIVE: R E L A T I V E;
PASSWORD: P A S S W O R D;
DUPLICATES: D U P L I C A T E S;
TAPE: T A P E;
FD: F D;
SD: S D ;
TOP: T O P;
EQUAL: E Q U A L;
AND: A N D;
POSITIVE: P O S I T I V E;
NEGATIVE: N E G A  T I V E;
GREATER: G  R E A T E R;
THAN: T H A N;
LESS: L E S S;
OR: O R;
KANJI: K A N J I;
DBCS: D B C S;
NUMERIC: N U M E R I C;
ALPHABETIC_LOWER: A L P H A B E T I C '-' L O W E R;
ALPHABETIC_UPPER: A L P H A B E T I C '-' U P P E R;
ALPHABETIC: A L P H A B E T I C;
USAGE: U S A G E;
BINARY: B I N A R Y;
COMP: C O M P;
COMP_1: C O M P '-' '1';
COMP_2: C O M P '-' '2';
COMP_3: C O M P '-' '3';
COMP_4: C O M P '-' '4';
COMP_5: C O M P '-' '5';
COMPUTATIONAL: C O M P U T A T I O N A L;
COMPUTATIONAL_1: C O M P U T A T I O N A L '-' '1';
COMPUTATIONAL_2: C O M P U T A T I O N A L '-' '2';
COMPUTATIONAL_3: C O M P U T A T I O N A L '-' '3';
COMPUTATIONAL_4: C O M P U T A T I O N A L '-' '4';
COMPUTATIONAL_5: C O M P U T A T I O N A L '-' '5';
PROCEDURE_POINTER: P R O C E D U R E '-' P O I N T E R;
FUNCTION_POINTER: F U N C T I O N '-' P O I N T E R;
OBJECT: O B J E C T;
METACLASS: M E T A C L A S S ;
DISPLAY: D I S P L A Y;
DISPLAY_1: D I S P L A Y '-' '1';
INDEX: I N D E X;
PACKED_DECIMAL: P A C K E D '-' D E C I M A L;
POINTER: P O I N T E R;
VALUES: V A L U E S;
LEFT: L E F T;
SYNCHRONIZED: S Y N C H R O N I Z E D;
LEADING: L E A D I N G;
TRAILING: T R A I L I N G;
PICTURE: P I C T U R E;
PIC: P I C;
INDEXED: I N D E X E D;
BY: B Y;
ASCENDING: A S C E N D I N G;
DESCENDING: D E S C E N D I N G;
JUSTIFIED: J U S T I F I E D;
JUST: J U S T;
RIGHT: R I G H T;
BLANK: B L A N K;
WHEN: W H E N;
RENAMES: R E N A M E S;
SEPARATE: S E P A R A T E;
SYNC: S Y N C;
OCCURS: O C C U R S;
TIMES: T I M E S;
BASIS: B A S I S;
PROCESS: P R O C E S S;
INSERT: I N S E R T;
RESET: R E S E T;
TRACE: T R A C E;
SERVICE: S E R V I C E;
RELOAD: R E L O A D;
OVERFLOW: O V E R F L O W;
EXCEPTION: E X C E P T I O N;
INVALID: I N V A L I D;
ALTER: A L T E R;
PROCEED:  P R O C E E D;
CALL: C A L L;
REFERENCE: R E F E R E N C E;
CONTENT: C O N T E N T;
END_CALL: E N D '-' C A L L;
CANCEL: C A N C E L;
CLOSE: C L O S E;
REMOVAL: R E M O V A L;
NO: N O;
REWIND: R E W I N D;
LOCK: L O C K;
COMPUTE: C O M P U T E;
END_COMPUTE: E N D '-' C O M P U T E ;
CONTINUE: C O N T I N U E;
DELETE: D E L E T E;
END_DELETE: E N D '-' D E L E T E;
UPON: U P O N;
ADVANCING: A D V A N C I N G;
DIVIDE: D I V I D E;
INTO: I N T O;
END_DIVIDE: E N D '-' D I V I D E;
REMAINDER: R E M A I N D E R;
ENTRY:  E N T R Y;
EVALUATE: E V A L U A T E;
TRUE: T R U E;
FALSE:  F A L S E;
OTHER: O T H E R;
END_EVALUATE: E N D '-' E V A L U A T E;
ANY: A N Y;
EXIT: E X I T;
MORE_LABELS: M O R E '-' L A B E L S;
IF: I F;
THEN: T H E N;
NEXT: N E X T;
SENTENCE: S E N T E N C E;
ELSE: E L S E;
END_IF: E N D '-' I F;
INITIALIZE: I N I T I A L I Z E;
REPLACING: R E P L A C I N G;
ALPHANUMERIC: A L P H A N U M E R I C;
ALPHANUMERIC_EDITED: A L P H A N U M E R I C '-' E D I T E D;
NUMERIC_EDITED: N U M E R I C '-' E D I T E D;
EGCS: E G C S;
INSPECT: I N S P E C T;
TALLYING: T A L L Y I N G;
CONVERTING: C O N V E R T I N G;
FIRST: F I R S T;
BEFORE: B E F O R E;
AFTER: A F T E R;
MERGE: M E R G E;
ASCEDNING: A S C E D N I N G;
OUTPUT: O U T P U T;
MOVE: M O V E;
MULTIPLY: M U L T I P L Y;
END_MULTIPLY: E N D '-' M U L T I P L Y;
OPEN: O P E N;
INPUT: I N P U T;
REVERSED: R E V E R S E D;
I_O: I '-' O;
EXTEND:  E X T E N D;
PERFORM: P E R F O R M;
END_PERFORM: E N D '-' P E R F O R M;
TEST: T E S T;
UNTIL: U N T I L;
READ: R E A D;
END_READ: E N D '-' R E A D;
RELEASE: R E L E A S E;
RETURN: R E T U R N;
END_RETURN: E N D '-' R E T U R N;
REWRITE: R E W R I T E;
END_REWRITE: E N D '-' R E W R I T E;
SEARCH: S E A R C H;
END_SEARCH: E N D '-' S E A R C H;
SET: S E T;
UP: U P;
DOWN: D O W N;
ORDER: O R D E R;
START: S T A R T;
END_START: E N D '-' S T A R T;
STOP : S T O P;
RUN: R U N;
STRING: S T R I N G;
DELIMITED: D E L I M I T E D;
END_SUBTRACT: E N D '-' S U B T R A C T;
UNSTRING: U N S T R I N G;
WRITE: W R I T E;
END_STRING: E N D '-' S T R I N G;
SUBTRACT: S U B T R A C T;
USE: U S E;
BEGINNING: B E G I N N I N G;
ENDING: E N D I N G;
PROCEDURES: P R O C E D U R E S;
COUNT: C O U N T;
END_UNSTRING: E N D '-' U N S T R I N G;
LINE: L I N E;
PAGE: P A G E;
END_WRITE: E N D '-' W R I T E;
END_OF_PAGE: E N D '-' O F '-' P A G E;
EOP: E O P;
COPY: C O P Y
    | P R E P C O P Y;
SUPPRESS: S U P P R E S S;
REPOSITORY: R E P O S I T O R Y;
ACCESS: A C C E S S;
ORGANIZATION: O R G A N I Z A T I O N;
SEQUENTIAL: S E Q U E N T I A L;
RANDOM: R A N D O M;
DYNAMIC: D Y N A M I C;
EXEC: E X E C;
CICS : C I C S;
SQL : S Q L;
CURRENT_DATE: C U R R E N T '-' D A T E;
FUNCTION: F U N C T I O N;
ACOS: A C O S;
ABS: A B S;
MOD: M O D;
XML: X M L;
END_XML: E N D '-' X M L;
GENERATE: G E N E R A T E;
PARSE: P A R S E;
PROCESSING: P R O C E S S I N G;
RETURNING: R E T U R N I N G;
ANNUITY: A N N U I T Y;
ASIN: A S I N;
ATAN: A T A N;
CHAR: C H A R;
COS: C O S;
DATE_OF_INTEGER: D A T E '-' O F '-' I N T E G E R;
DATE_TO_YYYYMMDD: D A T E '-' T O '-' Y Y Y M M D D;
DATEVAL : D A T E V A L;
DAY_OF_INTEGER: D A Y '-' O F '-' I N T E G E R;
DAY_TO_YYYYMMDD: D A Y '-' T O '-' Y Y Y M M D D;
DISPLAY_OF: D I S P L A Y '-' O F;
FACTORIAL: F A C T O R I A L;
INTEGER: I N T E G E R;
INTEGER_OF_DATE: I N T E G E R '-' O F '-' D A T E;
INTEGER_OF_DAY: I N T E G E R '-' O F '-' D A Y;
INTEGER_PART: I N T E G E R '-' P A R T;
LOG: L O G;
LOG10: L O G '1' '0';
LOWER_CASE: L O W E R '-' C A S E;
MAX: M A X;
MEAN: M E A N;
MEDIAN: M E D I A N;
MIDRANGE: M I D R A N G E;
MIN: M I N;
NATIONAL_OF: N A T I O N A L '-' O F;
NUMVAL: N U M V A L;
NUMVAL_C: N U M V A L '-' C;
ORD: O R D;
ORD_MAX: O R D '-' M A X;
ORD_MIN: O R D '-' M I N;
PRESENT_VALUE: P R E S E N T '-' V A L U E;
RANGE: R A N G E;
REM: R E M;
REVERSE: R E V E R S E;
SIN: S I N;
SQRT: S Q R T;
STANDARD_DEVIATION: S T A N D A R D '-' D E V I A T I O N;
SUM: S U M;
TAN: T A N;
UNDATE: U N D A T E;
UPPER_CASE: U P P E R '-' C A S E;
VARIANCE: V A R I A N C E;
YEAR_TO_YYYY: Y E A R '-' T O '-' Y Y Y Y;
YEARWINDOW: Y E A R W I N D O W;
TYPE: T Y P E;
VARBINARY: V A R B I N A R Y;
CLOB: C L O B;
DBCLOB: D B C L O B;
BLOB: B L O B;
FORMAT: F O R M A T;
TIMESTAMP: T I M E S T A M P;
YYYYMMDD: Y Y Y Y M M D D;
YYYYDDD: Y Y Y Y D D D;
IDMS : I D M S;
MODULE: M O D U L E;
OBTAIN: O B T A I N;
CALC: C A L C;
WITHIN: W I T H I N;
FIND: F I N D;
IDMS_CONTROL: I D M S '-' C O N T R O L;
PROTOCOL: P R O T O C O L;
DEBUG: D E B U G;
MANUAL: M A N U A L;
SCHEMA: S C H E M A;
DB: D B;
BATCH: B A T C H;
IDMS_DC: I D M S '-' D C;
VERSION: V E R S I O N;
CURRENT: C U R R E N T;
PRIOR: P R I O R;
LAST: L A S T;
VIA: V I A;
DIRECT: D I R E C T;
BIND: B I N D;
RUN_UNIT: R U N '-' U N I T;
DICTNODE: D I C T N O D E;
DICTNAME: D I C T N A M E;
NODE: N O D E;
DBNAME: D B N A M E;
PROGRAM_NAME: P R O G R A M '-' N A M E;
READY: R E A D Y;
USAGE_MODE: U S A G E '-' M O D E;
RETRIEVAL: R E T R I E V A L;
UPDATE: U P D A T E;
PROTECTED: P R O T E C T E D;
EXCLUSIVE: E X C L U S I V E;
ERASE: E R A S E;
PERMANENT: P E R M A N E N T;
SELECTIVE: S E L E C T I V E;
MEMBERS: M E M B E R S ;
STORE: S T O R E;
COMMIT: C O M M I T;
TASK: T A S K;
ROLLBACK: R O L L B A C K;
GET: G E T;
QUEUE: Q U E U E;
KEEP: K E E P ;
MODIFY: M O D I F Y;
SHARED: S H A R E D;
DISCONNECT: D I S C O N N E C T;
CONNECT: C O N N E C T;
PAGE_INFO: P A G E '-' I N F O;
OWNER: O W N E R;
IDMS_STATISTICS: I D M S '-' S T A T I S T I C S;
FINISH: F I N I S H;
TRANSFER: T R A N S F E R;
CONTROL: C O N T R O L;
LINK : L I N K;
DC_BATCH: D C '-' B A T C H;
SUBSCHEMA_NAMES: S U B S C H E M A '-' N A M E S;
IDMS_RECORDS: I D M S '-' R E C O R D S;
LEVELS: L E V E L S;
INCREMENTED: I N C R E M E N T E D;
DB_KEY: D B '-' K E Y;
ABEND: A B E N D;
CODE: C O D E;
DUMP: D U M P;
NODUMP: N O D U M P;
EXITS: E X I T S;
INVOKED: I N V O K E D;
IGNORED: I G N O R E D;
STATISTICS: S T A T I S T I C S;
NOWRITE: N O W R I T E;
LTERM: L T E R M;
PTERM: P T E R M;
SYSVERSION: S Y S V E R S I O N;
USER: U S E R;
SCREENSIZE: S C R E E N S I Z E;
SYSTEM: S Y S T E M;
ATTACH: A T T A C H;
PRIORITY: P R I O R I T Y;
WAIT: W A I T;
NOWAIT: N O W A I T;
DBNODE: D B N O D E;
NODENAME: N O D E N A M E;
CHANGE: C H A N G E;
CHECK : C H E C K;
STORAGE: S T O R A G E;
DC: D C;
NORMAL: N O R M A L;
ABORT: A B O R T;
IMMEDIATE: I M M E D I A T E;
TIMEOUT: T I M E O U T;
INTERVAL: I N T E R V A L;
INTERNAL: I N T E R N A L;
NAME: N A M E;
SCRATCH: S C R A T C H;
TABLE: T A B L E;
LOADLIB: L O A D L I B;
DEQUEUE: D E Q U E U E;
ENQUEUE: E N Q U E U E;
WHERE: W H E R E;
DUPLICATE: D U P L I C A T E;
STGID: S T G I D;
NOLOCK: N O L O C K;
SESSION: S E S S I O N;
ENDPAGE: E N D P A G E ;
LONG: L O N G ;
SHORT: S H O R T;
LOCATION: L O C A T I O N;
BELOW: B E L O W;
EDIT: E D I T;
INQUIRE: I N Q U I R E ;
AID: A I D;
UNFORMATTED: U N F O R M A T T E D;
TRUNCATED: T R U N  A T E D;
CHANGED: C H A N G E D;
EXTRANEOUS: E X T R A N E O U S;
DFLD: D F L D;
NONE: N O N E;
SOME: S O M E;
BUT: B U T ;
YES: Y E S;
IDENTICAL: I D E N T I C A L;
DIFFERENT: D I F F E R E N T;
CORRECT: C O R R E C T;
LONGTERM: L O N G T E R M;
NOTIFY: N O T I F Y;
NOTIFICATION: N O T I F I C A T I O N;
SHARE: S H A R E;
UPGRADE: U P G R A D E;
LOAD: L O A D;
IO: I O ;
NOIO: N O I O;
DATASTREAM: D A T A S T R E A M;
DETAIL: D E T A I L;
HEADER: H E A D E R;
RETURNKEY: R E T U R N K E Y;
OUT: O U T;
ATTRIBUTE: A T T R I B U T E;
NEWPAGE: N E W P A G E;
LITERALS: L I T E R A L S;
MESSAGE: M E S S A G E;
NEW: N E W;
RESUME: R E S U M E;
OUTIN: O U T I N;
TEMPORARY: T E M P O R A R Y;
WCC: W C C;
RESETMDT: R E S E T M D T;
NOMDT: N O M D T;
RESETKBD: R E S E T K B D;
NOKBD: N O K B D;
ALARM: A L A R M;
NOALARM: N O A L A R M;
STARTPRT: S T A R T P R T;
NOPRT: N O P R T;
NLCR: N L C R;
CR40: '4' '0' C R;
CR64: '6' '4' C R;
CR80: '8' '0' C R;
EXCEPT: E X C E P T;
EAU: E A  U;
NODEADLOCK: N O D E A D L O C K;
FIELDS: F I E L D S;
BACKSCAN: B A C K S C A N;
NOBACKSCAN: N O B A C K S C A N;
JUSTIFY: J U S T I F Y;
PAD: P A D ;
ACTIVE: A C T I V E;
ATTRIBUTES: A T T R I B U T E S;
SKIP: S K I P;
ALPHAMERIC: A L P H A M E R I C;
UNPROTECTED: U N P R O T E C T E D;
DARK: D A R K;
BRIGHT: B R I G H T;
DETECT: D E T E C T ;
MDT: M D T;
NOBLINK: N O B L I N K;
NORMAL_VIDEO: N O R M A L '-' V I D E O;
NOUNDERSCORE: N O U N D E R S C O R E;
UNDERSCORE: U N D E R S C O R E;
NOCOLOR: N O C O L O R;
BLUE: B L U E;
RED: R E D;
PINK: P I N K;
GREEN: G R E E N;
TURQUOISE: T U R Q U O I S E;
YELLOW: Y E L L O W;
WHITE: W H I T E;
POST: P O S T;
CLEAR: C L E A R;
PUT: P U T;
RETENTION: R E T E N T I O N;
SEND: S E N D;
ONLY: O N L Y;
DEST: D E S T;
SECONDS: S E C O N D S;
BACKPAGE: B A C K P A G E;
BROWSE: B R O W S E;
ECHO: E C H O;
NOBACKPAGE: N O B A C K P A G E;
BUFFER: B U F F E R;
ALWAYS: A L W A Y S;
TIMER: T I M E R;
SNAP: S N A P;
STARTPAGE: S T A R T P A G E;
AUTODISPLAY: A U T O D I S P L A Y;
NOAUTODISPLAY: N O A U T O D I S P L A Y;
NORETURN: N O R E T U R N;
XCTL: X C T L;
REDISPATCH: R E D I S P A T C H;
JOURNAL: J O U R N A L;
SPAN: S P A N;
NOSPAN: N O S P A N;
PARMS: P A R M S;
REPLY: R E P L Y;
PREFIX: P R E F I X;
TEXT: T E X T;
PRINTER: P R I N T E R;
ENDRPT: E N D R P T;
CONTENTS: C O N T E N T S;
COPIES: C O P I E S;
DESTINATION: D E S T I N A T I O N;
HOLD: H O L D;
WATT: W A T T;
EMPTY: E M P T Y;
MEMBER: M E M B E R;
EXTENDED: E X T E N D E D;
FIELD: F I E L D;
PAGING: P A G I N G;
MAP_CONTROL: M A P '-' C O N T R O L;
TRANSACTION: T R A N S A C T I O N;
EXTERNALLY_DESCRIBED_KEY: E X T E R N A L L Y '-' D E S C R I B E D '-' K E Y;
CONTROL_AREA: C O N T R O L '-' A R E A;
COMMITMENT: C O M M I T M E N T;
CLOCK_UNITS: C L O C K '-' U N I T S;
CONSTANT: C O N S T A N T;
AS: A S;
LIKE: L I K E;
TYPEDEF: T Y P E D E F;
NATIONAL: N A T I O N A L;
LOCALE: L O C A L E;
END_ACCEPT: E N D '-' A C C E P T;
CRT: C R T;
LIBRARY: L I B R A R Y;
COLUMN: C O L U M N;
COL: C O L;
NUMBER: N U M B E R;
AUTO: A U T O;
AUTO_SKIP: A U T O '-' S K I P;
BELL: B E L L;
BEEP: B E E P;
BLINK: B L I N K;
FULL: F U L L;
LENGTH_CHECK: L E N G T H '-' C H E C K;
HIGHLIGHT: H I G H L I G H T;
REQUIRED: R E Q U I R E D;
EMPTY_CHECK: E M P T Y '-' C H E C K;
REVERSE_VIDEO: R E V E R S E '-' V I D E O;
SECURE: S E C U R E;
GRID: G R I D;
LEFTLINE: L E F T L I N E;
NO_ECHO: N O '-' E C H O;
UNDERLINE: U N D E R L I N E;
RIGHT_JUSTIFY: R I G H T '-' J U S T I F Y;
SPACE_FILL: S P A C E '-' F I L L;
TRAILING_SIGN: T R A I L I N G '-' S I G N;
ZERO_FILL: Z E R O '-' F I L L;
PROMPT: P R O M P T;
FOREGROUND_COLOR: F O R E G R O U N D '-' C O L O R;
FOREGROUND_COLOUR: F O R E G R O U N D '-' C O L O U R;
BACKGROUND_COLOR: B A C K G R O U N D '-' C O L O R;
BACKGROUND_COLOUR: B A C K G R O U N D '-' C O L O U R;
LEFT_JUSTIFY: L E F T '-' J U S T I F Y;
DAY: D A Y;
ACQUIRE: A C Q U I R E;
DROP: D R O P;
ENTER: E N T E R;
CURSOR: C U R S O R;
SCREEN: S C R E E N;
EVENT: E V E N T;
REPORT: R E P O R T;
REPORTS: R E P O R T S;
BYTE_LENGTH: B Y T E '-' L E N G T H;
BINARY_CHAR: B I N A R Y '-' C H A R;
SIGNED: S I G N E D;
UNSIGNED: U N S I G N E D;
BINARY_C_LONG: B I N A R Y '-' C '-' L O N G;
BINARY_DOUBLE: B I N A R Y '-' D O U B L E;
BINARY_LONG: B I N A R Y '-' L O N G;
BINARY_SHORT: B I N A R Y '-' S H O R T;
COMPUATIONAL_X: C O M P U T A T I O N A L '-' X;
SIGNED_INT: S I G N E D '-' I N T;
SIGNED_LONG: S I G N E D '-' L O N G;
SIGNED_SHORT: S I G N E D '-' S H O R T;
UNSIGNED_INT: U N S I G N E D '-' I N T;
UNSIGNED_LONG: U N S I G N E D '-' L O N G;
UNSIGNED_SHORT: U N S I G N E D '-' S H O R T;
AUTOTERMINATE: A U T O T E R M I N A T E;
OVERLINE: O V E R L I N E;
EOL: E O L;
EOS: E O S;
PLUS: P L U S;
LOWLIGHT: L O W L I G H T;
CHAINING: C H A I N I N G;
DEFAULT: D E F A U L T;
ADD_DURATION: A D D '-' D U R A T I O N;
CONVERT_DATE_TIME: C O N V E R T '-' D A T E '-' T I M E;
EXTRACT_DATE_TIME: E X T R A C T '-' D A T E '-' T I M E;
TEST_DATE_TIME: T E S T '-' D A T E '-' T I M E;
FIND_DURATION: F I N D '-' D U R A T I O N;
LOCALE_DATE: L O C A L E '-' D A T E;
LOCALE_TIME: L O C A L E '-' T I M E;
SUBTRACT_DURATION: S U B T R A C T '-' D U R A T I O N;
TRIM: T R I M;
TRIMR: T R I M R;
TRIML: T R I M L;
UTF8STRING: U T F '8' S T R I N G;
COLUMNS: C O L U M N S;
SCROLL: S C R O L L;
NULL_KEY_MAP: N U L L '-' K E Y '-' M A P;
END_DISPLAY: E N D '-' D I S P L A Y;
CRT_UNDER: C R T '-' U N D E R;
PARAGRAPH: P A R A G R A P H;
CYCLE: C Y C L E;
FREE: F R E E;
DBCS_EDITED: D B C S '-' E D I T E D;
NATIONAL_EDITED: N A T I O N A L '-' E D I T E D;
INITIATE: I N I T I A T E;
LC_ALL: L C '-' A L L;
LC_COLLATE: L C '-' C O L L A T E;
LC_CTYPE: L C '-' C T Y P E;
LC_MESSAGES: L C '-' M E S S A G E S;
LC_MONETARY: L C '-' M O N E T A R Y;
LC_NUMERIC: L C '-' N U M E R I C;
LC_TIME: L C '-' T I M E;
LC_TOD: L C '-' T O D;
PRINTING: P R I N T I N G;
TERMINATE: T E R M I N A T E;
TRANSFORM: T R A N S F O R M;
UNLOCK: U N L O C K;
REPORTING: R E P O R T I N G;
FILE_STREAM: F I L E '-' S T R E A M;
APPEND: A P P E N D;
OVERWRITE: O V E R W R I T E;
CONTROL_: '*' C O N T R O L;
CBL_: ~[ ] C B L;
CBL: C B L;
SOURCE: S O U R C E;
NOSOURCE: N O S O U R C E;
LIST: L I S T;
NOLIST: N O L I S T;
MAP: M A P ;
NOMAP: N O M A P;
EJECT: E J E C T;
REPLACE: R E P L A C E;
SKIP1: S K I P '1';
SKIP2: S K I P '2';
SKIP3: S K I P '3';
TITLE: T I T L E;
NULL_MAP: N U L L '-' M A P;
TERMINAL: T E R M I N A L;
INDICATOR: I N D I C A T O R;
INDICATORS: I N D I C A T O R S;
INDIC: I N D I C;
MODIFIED: M O D I F I E D;
SUBFILE: S U B F I L E;
STARTING: S T A R T I N G;
ROLLING: R O L L I N G;
P_P_INCLUDE: '+' '+' I N C L U D E;
POSITIONING: P O S I T I O N I N G;
COMMON: C O M M O N;
RECURSIVE: R E C U R S I V E;

GREATER_THAN_: '>';
LESS_THAN_: '<';
GREATER_THAN_EQUAL_TO_: '>=';
LESS_THAN_EQUAL_TO_: '<=';
EQUAL_: '=';
NOT_EQUAL_: '<>';
PLUS_: '+';
MINUS_: '-';
ASTERICK_: '*';
DOUBLE_ASTERICK_: '**';
F_SLASH: '/';

LEVEL_66: '66';
LEVEL_77: '77';
LEVEL_88: '88';
SEQUENCE_NUMBER: [0-9][0-9][0-9][0-9][0-9][0-9];
SEQUENCE_NUMBER_RANGE: SEQUENCE_NUMBER '-' SEQUENCE_NUMBER;
LEVEL_NUMBER: '0'? [1-9]
            | [1-4] [0-9]
            | '66'
            | '77'
            | '88';
PRIORITY_NUMBER: DIGIT DIGIT?;
DECIMAL_: ('+' | '-')? [0-9]+? '.' [0-9]+ E ('+' | '-')? [0-9]+;
INTEGER_: [0-9]+;
INTEGER_WITH_SIGN: ('+' | '-') [0-9]+;
NUMERIC_: ('+' | '-')? ([0-9]* [,.] [0-9]+ | [0-9]+);
NONNUMERIC_: '\''  ('\'\'' | ~['])* '\''
          |  '"'   ('""'   | ~["])* '"'
           ;

ALPHABETIC_USER_DEFINED_WORD:  ([0-9]+ '-'*)* [0-9]* [A-Za-z] [A-Za-z0-9]* ('-'+ [A-Za-z0-9]+)*;


COBOL_WORD: [A-Za-z0-9]+ ('-'? [A-Za-z0-9]+)*;
COPY_OPERAND: '==' .*? '==';
ZERO_: '0'+;

///////////////////////////////////////////////////////////////////////////////////////////////

cobol_program: procedure_division;
                     
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////
// When the alternative is removed, C# parses very quickly (just like Java)
/////////////////////////////////////////////////
procedure_division: 
              PROCEDURE DIVISION DOT sentence* paragraph* section* #ProcedureDivisionWithSections
            ;



section: section_name SECTION priority_number? DOT   sentence* paragraph*;
paragraph: paragraph_name DOT sentence*;
section_name: cobol_word;
paragraph_name: cobol_word;
report_name: cobol_word;
data_name:alphabetic_user_defined_word;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


sentence: statement_list DOT #NormalSentence
        ;
statement_list: statement+;

statement: if_statement
         | move_statement
         | write_statement
         | perform_statement
		 | stop_statement
         ;
		 
		 stop_statement: STOP RUN ( 
                (RETURNING | GIVING)?
                (
                           (ADDRESS OF)? data_ref_or_literal
                           | integer (SIZE IS? integer)?
                )          
                         )? # StopRun
              | STOP literal # StopLiteral;
            procedure_name:paragraph_name ((IN | OF) section_name)?;
			
			perform_statement:  perform_inline_statement
                 |  perform_from_to_statement;

perform_inline_statement: PERFORM statement_list? END_PERFORM
                        | PERFORM perform_varying_phrase perform_after_phrase statement_list? END_PERFORM
                        | PERFORM (identifier | integer) TIMES statement_list? END_PERFORM
                        | PERFORM perform_until_phrase statement_list? END_PERFORM;

perform_from_to_statement: PERFORM procedure_name ((THROUGH | THRU) procedure_name)?
                         | PERFORM procedure_name ((THROUGH | THRU) procedure_name)? perform_varying_phrase perform_after_phrase
                         | PERFORM procedure_name ((THROUGH | THRU) procedure_name)? (identifier | integer) TIMES
                         | PERFORM procedure_name ((THROUGH | THRU) procedure_name)? perform_until_phrase;

perform_until_phrase: (WITH? TEST (BEFORE | AFTER))? UNTIL condition;

perform_varying_phrase: (WITH? TEST (BEFORE | AFTER))? VARYING (identifier | index_name) FROM (identifier | index_name | literal) BY (identifier | literal) UNTIL condition;

perform_after_phrase: (AFTER (identifier | index_name) FROM (identifier | index_name | literal) BY data_ref_or_literal UNTIL condition)*;


if_statement
    : IF condition 
      THEN? branch
      ( ELSE (branch) )? 
      END_IF?;

branch: NEXT SENTENCE
      | statement+
	  |;
		
move_statement: MOVE data_ref_or_literal TO identifier+ # MoveSimple
              | MOVE (CORRESPONDING | CORR) identifier TO identifier # MoveCorr;


record_name: identifier;

write_statement: WRITE record_name (FROM identifier)?
		 write_advancing_clause?
                 (NULL_MAP IS? identifier)?
        	 
		 
		 END_WRITE? #WriteSequentialFiles
               | WRITE record_name (FROM identifier)?
                 (FORMAT IS? data_ref_or_literal)?
                 (NULL_KEY_MAP IS? identifier)?
                 (NULL_MAP IS? identifier)?
                 
		 END_WRITE? #WriteIndexedAndRelativeFiles
               | WRITE record_name (FROM identifier)?
                 (FORMAT IS? data_ref_or_literal)?
                 ( (INDICATOR | INDICATORS | INDIC) (IS | ARE)? identifier)?
                 
                 END_WRITE? #WriteFormatFile
               | WRITE record_name (FROM identifier)?
                 FORMAT IS? data_ref_or_literal
                 (TERMINAL IS? data_ref_or_literal)?
                 (STARTING AT? LINE? data_ref_or_literal)?
                 rolling_phrase
                 ( (INDICATOR | INDICATORS | INDIC) (IS | ARE)? identifier)?
                 END_WRITE? #WriteTransactionNonSubfile
               | WRITE SUBFILE record_name (FROM identifier)?
                 FORMAT IS? data_ref_or_literal
                 (TERMINAL IS? data_ref_or_literal)?
                 ( (INDICATOR | INDICATORS | INDIC) (IS | ARE)? identifier)?
                 
                 END_WRITE? #WriteTransactionSubfile;

rolling_phrase: (BEFORE | AFTER) ROLLING (LINE | LINES)? data_ref_or_literal
                (THROUGH | THRU)?
                data_ref_or_literal (UP | DOWN) data_ref_or_literal (LINES | LINE)?;


write_advancing_clause: (BEFORE | AFTER) (ADVANCING | POSITIONING)? ( (identifier | integer | ZERO) (LINE | LINES)? | mnemonic_name | PAGE);









//////////////////////////////////////////////////////////////////////




// VALUES

mnemonic_name: alphabetic_user_defined_word;
environment_name: cobol_word;



literal: (NONNUMERIC_ | NUMERIC_)
       | integer
       | figurative_constant;


identifier: qualified_data_name ( L_PAREN subscript R_PAREN )*
          ( L_PAREN leftmost_character_position COLON length? R_PAREN)?
          | LINAGE_COUNTER (( IN | OF) file_name)?;

qualified_data_name: data_name ((IN | OF) data_name)* ((IN | OF) file_name)?
                   | special_register
                   | (NULL | NULLS)
                   ;

special_register:ADDRESS OF? data_name
                | LENGTH OF? identifier
                |(DEBUG_ITEM
                 | RETURN_CODE
                 | SHIFT_OUT
                 | SHIFT_IN
                 | SORT_CONTROL
                 | SORT_CORE_SIZE
                 | SORT_FILE_SIZE
                 | SORT_MESSAGE
                 | SORT_MODE_SIZE
                 | SORT_RETURN
                 | TALLY
                 | WHEN_COMPILED
                 );

subscript: ( integer
           | numeric
           | ALL
           | qualified_data_name (( PLUS_ | MINUS_ ) (literal | qualified_data_name) )?
           | index_name (( PLUS_ | MINUS_  ) (literal | qualified_data_name) )?
           )+;




index_name:alphabetic_user_defined_word;
file_name: alphabetic_user_defined_word;
cd_name: alphabetic_user_defined_word;
rd_name: alphabetic_user_defined_word;

leftmost_character_position: arithmetic_expression;

length: arithmetic_expression;

arithmetic_expression: times_div ( (PLUS_ | MINUS_) times_div)*;
times_div:power ((ASTERICK_ | F_SLASH) power)*;
power: ( PLUS_ | MINUS_)? basis ( DOUBLE_ASTERICK_ basis)*;
basis: identifier
     | literal
     | L_PAREN arithmetic_expression R_PAREN;


figurative_constant: ALL literal
                   | (ZERO
                   | ZEROS
                   | ZEROES
                   | SPACE
                   | SPACES
                   | HIGH_VALUE
                   | HIGH_VALUES
                   | LOW_VALUE
                   | LOW_VALUES
                   | QUOTE
                   | QUOTES
                   | NULL
                   | NULLS
                     );


condition: combinable_condition ((AND | OR) combinable_condition)*;

combinable_condition: 
				      NOT? simple_condition
                    | abbreviated_combined_relation_conditions
                    | abbreviated_condition;

simple_condition:
				  
				  relation_condition
				| L_PAREN condition R_PAREN
                | class_condition
				| condition_name_condition
                | sign_condition
                ; 

class_condition: (identifier | L_PAREN identifier R_PAREN) IS? NOT?
                 (identifier
                   | NUMERIC
                   | ALPHABETIC
                   | ALPHABETIC_LOWER
                   | ALPHABETIC_UPPER
                   | DBCS 
                   | KANJI
                   | EMPTY
                   | MEMBER
                 );

condition_name_condition: condition_name_reference;

condition_name_reference: condition_name
                          ((IN | OF) data_name)*
                          ((IN | OF) file_name)?
						  (L_PAREN subscript R_PAREN )*
                        | 
						condition_name ( (IN | OF ) mnemonic_name)*;

relation_condition: arithmetic_expression (relational_operator abbreviation_leaf | sign_condition);

relational_operator: IS? NOT?
                     ( (GREATER THAN? | GREATER_THAN_ | LESS THAN? | LESS_THAN_ | EQUAL TO? | EQUAL_ | NOT_EQUAL_)
                        | GREATER THAN? OR EQUAL TO?
                        | GREATER_THAN_EQUAL_TO_
                        | LESS THAN? OR EQUAL TO?
                        | LESS_THAN_EQUAL_TO_);

sign_condition: IS? NOT? (POSITIVE | NEGATIVE | ZERO);  

negated_simple_condition: NOT EQUAL_? condition;

abbreviated_combined_relation_conditions: relation_condition abbreviation_rest
                                        | arithmetic_expression relational_operator L_PAREN NOT? arithmetic_expression abbreviation_rest R_PAREN
                                        | arithmetic_expression L_PAREN NOT? relational_operator arithmetic_expression abbreviation_rest R_PAREN;


abbreviated_condition: relational_operator? abbreviation_leaf;

abbreviation_rest: ( (AND | OR )  relational_operator? abbreviation_leaf)+;

abbreviation_leaf: arithmetic_expression
                 | L_PAREN arithmetic_expression abbreviation_rest R_PAREN;

data_ref_or_literal: identifier | literal;






/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////



zero: ZERO_;

alphabetic_user_defined_word: ALPHABETIC_USER_DEFINED_WORD;

cobol_word: alphabetic_user_defined_word
          | COBOL_WORD
          | level_number
          | integer
          ;

integer: (INTEGER_ | INTEGER_WITH_SIGN | SEQUENCE_NUMBER)
       | priority_number
       | level_number
       | DECIMAL_
       ;
       

numeric: integer
       | NUMERIC_;

level_number: LEVEL_NUMBER
            | PRIORITY_NUMBER
            | LEVEL_66
            | LEVEL_77
            | LEVEL_88;

priority_number: PRIORITY_NUMBER
               | level_number;
alphabet: COLLATING? SEQUENCE IS? alphabet_name;
alphabet_name: alphabetic_user_defined_word;
condition_value_clause: (VALUE | VALUES) (IS |ARE)? literal_or_literal_value_range+;
literal_or_literal_value_range: literal ((THROUGH | THRU) literal )?;
condition_name: alphabetic_user_defined_word;